//////////////////////////////////////////////////////////////////////////
//
//	VITAL Systems Inc. Copyright (c) 2002 - All Rights Reserved.
//  File: VSi Dnm Server Interface Lib
//  IDE : Visual Studio C++ 6.0 SP4
//
//	Description: 
//
//  Revision History :
//  Version		Date		Developer	
//	1.0			10/6/01		Robert Ortega	CAN sp2.31 release
//	2.0			4/4/02		JC				DNet updates
//
//////////////////////////////////////////////////////////////////////////

#ifndef _DNMCOMLIB_H_
#define _DNMCOMLIB_H_


class CDnmCOM
{

public:

	CDnmCOM();
	virtual ~CDnmCOM();

	bool ConnectDNM();

    long AddSlaveDevice( 
        /* [in] */ long MAC,
        /* [in] */ long Channel,
        /* [in] */ long EPRex,
        /* [in] */ long EPRpl,
        /* [in] */ long ConsSize,
        /* [in] */ long ProdSize );
      
    
     long GetDeviceState( 
        /* [in] */ long MAC,
        /* [in] */ long Channel,
        /* [out] */ long &devState );
        
    
     long SetConsumeData( 
        /* [in] */ long MAC,
        /* [in] */ long Channel,
        /* [in] */ unsigned char ConsDataByte,
        /* [in] */ long ConsIndex );
        
    
     long GetProduceData( 
        /* [in] */ long MAC,
        /* [in] */ long Channel,
        /* [out] */ unsigned char &pProdDataByte,
        /* [in] */ long ProdIndex );
            
	long GetDeviceErrorString( 
        /* [in] */ long MAC,
        /* [in] */ long Channel,
        /* [out] */ char *pStrBuffer,
		/* [in] */ long BufferSize );
        
    
     void PurgeDeviceList( 
        /* [in] */ long Channel);

private:
	void * vpDnmSrv;
            
};


#endif
