// cTst.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <conio.h>

#include "dnConst.h"
#include "DnmCOM.h"

int main(int argc, char* argv[])
{
	CDnmCOM dnmSrv;	// the Server Object

	if( CoInitialize( NULL ) != S_OK )
	{
		printf( "Ole problem\n" );
		return FALSE;
	}
		
	if( !dnmSrv.ConnectDNM() )
	{
		printf( "Unable to access DNM Server\n" );
		return 0;
	}

	printf( "DNM Server online\n" );

	dnmSrv.PurgeDeviceList( 0 );  // Delete all devices from Scan list on this channel

	// Add a slave device to scan list
	// MAC			2
	// Channel		0
	// EPR Explicit 0
	// EPR Poll		0
	// Consume Size 2
	// Produce Size 5

	if(	dnmSrv.AddSlaveDevice( 5, 0, 0, 200, 0, 2 ) != dn_SUCCESS )
	{
		printf( "Unable to slave device DeviceNet ScanList on Channel 1\n" );
		return 0;
	}

/*	// Add a slave device to scan list
	// MAC			3
	// Channel		0
	// EPR Explicit 0
	// EPR Poll		0
	// Consume Size 2
	// Produce Size 5

	if(	dnmSrv.AddSlaveDevice( 3, 0, 0, 0, 2, 5 ) != dn_SUCCESS )
	{
		printf( "Unable to slave device DeviceNet ScanList on Channel 1\n" );
		return 0;
	}
*/	
	Sleep( 10000 );  // wait for the device poll conection to establish

	long devState;
	if( dnmSrv.GetDeviceState( 5, 0, devState ) == dn_SUCCESS )
	{
		if( devState == dn_DEVICE_OFFLINE )
		{
			char pStr[50];

			dnmSrv.GetDeviceErrorString( 5, 0, pStr, 50 );
			printf( pStr );
			printf( "\n" );
			return 0;
		}
	}

	printf( "Device Online\n" );

	UCHAR devDat;
	char pStr[50];

	while( !kbhit() )
	{
		// get the device produced data
		if( dnmSrv.GetProduceData( 5, 0, devDat, 0 ) == dn_SUCCESS )
		{
			dnmSrv.GetDeviceErrorString( 5, 0, pStr, 50 );
			printf( "Device MAC 5 Inputs: %02X, %s\n", devDat, pStr );
		}
/*
		if( dnmSrv.GetProduceData( 3, 0, devDat, 0 ) == dn_SUCCESS )
		{
			dnmSrv.GetDeviceErrorString( 3, 0, pStr, 50 );
			printf( "Device MAC 3 Inputs: %02X, %s\n", devDat, pStr );
		}
*/
		Sleep( 10 );
	}


	getchar();

	return 0;
}
